<script lang="ts">
import Vue from 'vue';
import { debounce } from 'lodash';
import SearchIcon from '~/static/nuxt-images/icons/search.vue';

export default Vue.extend({
  name: 'SlpSearchBar',
  components: {
    SearchIcon,
  },
  props: {
    onClose: {
      type: Function,
      required: true,
    },
  },
  data() {
    return {
      distanceFromTop: 0,
    };
  },
  mounted() {
    this.resizeListener();
    this.setSearchBarDistanceFromTop();
  },
  methods: {
    search(event: KeyboardEvent) {
      const target = event.target as HTMLInputElement;
      if (event.key === 'Enter' && target) {
        window.location.hash = `#stq=${target.value}`;
      }
    },
    resizeListener() {
      window.addEventListener(
        'resize',
        debounce(() => {
          this.setSearchBarDistanceFromTop();
        }, 100),
      );
    },
    setSearchBarDistanceFromTop() {
      this.distanceFromTop = document
        .querySelector('#navigation')
        ?.getBoundingClientRect().height as number;
    },
  },
});
</script>

<template>
  <div class="searchbox" :style="{ top: distanceFromTop + 'px' }">
    <SearchIcon class="searchbox__icon" />
    <input
      ref="searchInput"
      class="searchbox__input st-header"
      type="text"
      placeholder="Search..."
      @keyup="search"
    />
    <button aria-label="Close search" class="searchbox__close" @click="onClose">
      &times;
    </button>
  </div>
</template>

<style lang="scss" scoped>
.searchbox {
  display: flex;
  align-items: center;
  position: fixed;
  top: 120px;
  left: 0;
  height: 58px;
  width: 100%;
  padding: 0 80px;
  z-index: 2000;
  background: $color-surface-50;
  overflow: hidden;
  transition: 0.2s cubic-bezier(0, 0, 0, 1);

  @media (max-width: $breakpoint-lg) {
    padding: 0 20px;
    top: 64px;
  }
}

.searchbox__input {
  width: calc(100% - 40px);
  height: 100%;
  margin: auto;
  padding: 0 10px;
  border: 0;
  color: $color-text-300;
  background: $color-surface-50;
  font-size: 16px;
  transition: 0.2s cubic-bezier(0, 0, 0, 1);
  &:focus {
    outline: 0;
    border-color: #554488;
  }
}

.search__close {
  font-size: 1.33rem;
  font-weight: 400;
}

.searchbox__icon,
.searchbox__close {
  border: 0;
}

.searchbox__close {
  font-size: 1.5rem;
}
</style>
